# Change Log

All notable changes to the ADOxx AdoScript extension are documented here.

The format is (hopefully) based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project (hopefully) adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]
### Added
* Added syntax highlighting for AQL queries only in files using the ".aql" extension.
* Added a whole new Editor for creating AQL queries that translate it into a well formed string that you can insert directly in your ADO code.
### Fixed
* Fixed bug ([#18](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/18)) so syntax highlighting for ALL now also works on files that contain only snippets of ALL.

## [1.1.0] - 2019-10-27
### Added
* Syntax highlighting for the ADOxx Library Language (ALL).
### Fixed
* Fixed bug ([#15](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/15)) where some valid procedure parameters were marked as illegal.

## [1.0.0] - 2019-10-18
### Removed
* The `preview` flag from the project.
### Fixed
* Fixed bug ([#1](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/1)) with LEO expressions not being identified in square brackets for assignment of array / map values.
* Fixed bug ([#2](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/2)) where the `IN` LEO operator wasn't known by the syntax highlighting.
* Fixed bug ([#9](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/9)) where `TODO` after starting a comment wasn't always recognized.
* Fixed bug ([#10](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/10)) by adding `trim` to the list of known LEO functions.
* Fixed bug ([#12](https://git.boc-group.eu/adoxx/adoscript-vs-code-support/issues/12)) by recognizing the ON_EVENT definitions in AdoScript.

## [0.3.0] - 2019-05-10
### Added
* Added the built-in functions for EXPRESSION type attributes to the LEO language.
### Changed
* Reworked LEO to include parts "above" a "LEO-expression", meaning LEO now considers a "LEO-program" instead of just a "LEO-expression".
  * This should allow to now have basic code highlighting for ANY LEO-program based language (GRAPHREP?, ATTRREP?, ...).
  * AdoScript builds upon the definitions from a "LEO-program", providing certain keywords and their specific structure that are explicitly identified and highlighted accordingly.
  * This should also make adding other languages that seem to be based on LEO easier in the future (GRAPHREP?, ATTRREP?, ...).
### Fixed
* LEO-expressions used in AdoScript are now the proper "LEO comma expression".

## [0.2.2] - 2019-05-04
### Fixed
* Fixed the README.md for gitlab and hopefully also for the VSC marketplace.

## [0.2.1] - 2019-05-02
### Added
* Marking the word TODO in comments with a `comment.todo.leo` scope.
* Added some code snippets for LEO and AdoScript:
  * cond - condition (if) statement in LEO.
  * fornum - numerical form of the for loop in LEO and AdoScript.
  * fortok - token form of the for loop in LEO and AdoScript.
  * if - if (condition) statement in AdoScript.
  * elsif - elsif (condition) statement in AdoScript.
  * else - else (condition) statement in AdoScript.
  * while - while loop in LEO and AdoScript.
  * cc... - CC calls to all the message ports in AdoScript.
* Added a LICENSE file based on MIT License.
* Added a banner for the VSC Marketplace.
### Changed
* Tightened a few rules for highlighting possible errors.
* Changed several scopes so that they are overall simpler and more consistent.
* Adapted some pattern names to better fit and be more consistent.
* Improved some of the regular expressions by removing unnecessary parts.
* Extended and rearranged documentation.
### Removed
* Removed support for the IF-ENDIF style (old), because it was messing with the scopes when having nested IF statements.
### Fixed
* Fixed bug where constant negative numbers would be considered wrong in AdoScript code if not in round brackets.
* Changed the rule for finding where a statement ends to also consider word boundaries.
* Fixed the `.sort(...)` function to provide scopes similar to the other built-in functions.

## [0.2.0] - 2019-04-22
### Changed
* Reworked entire code for syntax highlighting, splitting it into LEO (.leo files by default) and AdoScript (.asc files by default).
* Highlighting is more context sensitive and should be more precise allowing to find errors easier.

## [0.1.0] - 2019-04-21
### Added
* Initial version only for AdoScript that basically just tries to guess the right scope for the words with minimal context.